#include <WinUser32.mqh>
#import "user32.dll"
	int RegisterWindowMessageA(string lpString); 
	int GetParent(int hWnd);
#import

int TickRateMillisec = 1000;

int start() {
   int chartsCount = 0;
   int ownWindowHandle = 0;
   int parentHandle = 0;
   int firstChartHandle = 0;
   int chartHandle = 0;
   int chartsChildHandle = 0;
   int sleepingMillisec = 0;
   int sleepCount = 0;
   int MT4InternalMsg = 0;
   bool isPostingSuccess = false;
   
   if (TickRateMillisec < 200) {
      TickRateMillisec = 200;
   }

   while (!IsStopped()) {
      Comment("Ticking script added here!");

      chartsCount = 0;
      ownWindowHandle = WindowHandle(Symbol(), Period());
      if (ownWindowHandle > 0) {
      
         parentHandle = GetParent(ownWindowHandle);
         if (parentHandle > 0) {
         
            firstChartHandle = GetWindow(parentHandle, GW_HWNDFIRST);
            if (firstChartHandle > 0) {
            
               chartHandle = firstChartHandle;
               while (chartHandle > 0) {
                  chartsCount = chartsCount + 1;
                  chartHandle = GetWindow(chartHandle, GW_HWNDNEXT);
               }
            } else {
               Print("Cannot get firstChartHandle.");
               chartsCount = -1;
            }
         } else {
            Print("Cannot get parentHandle.");
            chartsCount = -1;
         }
      } else {
         Print("Cannot get ownWindowHandle.");
         chartsCount = -1;
      }

      sleepCount = 0;
      if (chartsCount > 0) {
         sleepingMillisec = TickRateMillisec / chartsCount;
         firstChartHandle = GetWindow(parentHandle, GW_HWNDFIRST);
         if (firstChartHandle > 0) {
         
            MT4InternalMsg = 0;
            chartHandle = firstChartHandle;
            while (chartHandle > 0) {
               if (MT4InternalMsg == 0) {
                  MT4InternalMsg = RegisterWindowMessageA("MetaTrader4_Internal_Message");
               }
               if (MT4InternalMsg != 0) {
                  chartsChildHandle = GetWindow(chartHandle, GW_CHILD);
                  if (chartsChildHandle > 0) {

                     isPostingSuccess = PostMessageA(chartsChildHandle, MT4InternalMsg, 2, 1);
                     if (!isPostingSuccess) {
                        Print("Cannot post tick.");
                        break;
                     }
                  } else {
                     Print("Cannot get chartsChildHandle.");
                     break;
                  }
               } else {
                  Print("Cannot register MT4InternalMsg.");
                  break;
               }
               chartHandle = GetWindow(chartHandle, GW_HWNDNEXT);
               Sleep(sleepingMillisec);
               sleepCount = sleepCount + sleepingMillisec;
            }
         } else {
            Print("Cannot get firstChartHandle.");
         }
      } else {
         Print("Cannot find charts.");
      }
      if (TickRateMillisec - sleepCount > 0) {
         Sleep(TickRateMillisec - sleepCount);
      }
   }
   Comment("");
   return(0);
}

